#!/usr/bin/env python
# -*- coding: utf-8 -*-

import wx
import os, sys


# ###########################################################
# Der Fenster-Rahmen für die Kurven-Settings.
class CurveSettingsFrame(wx.Frame):
  def __init__(self, parent, coldesc, pos=wx.DefaultPosition, size=wx.DefaultSize):
    wx.Frame.__init__(self, None, pos=pos, size=size, title="Kurven-Settings")

    self.parent=parent
    self.coldesc=coldesc
    self.Bind(wx.EVT_CLOSE, self.onClose)
    self.InitUI()
    self.Show()


  # ###########################################################
  # Bei close die aktuelle Fenster-Position ans Hauptprogramm
  # liefern.
  def onClose(self, event):
    sp=self.GetScreenPosition()
    ss=self.GetSizeTuple()
    self.parent.curveSettingsFeedback.SetValue("close,"+str(sp[0])+","+str(sp[1])+","+str(ss[0])+","+str(ss[1]))
    self.Destroy()


  # ###########################################################
  # Der eigentliche Fensterinhalt
  def InitUI(self):
    panel=wx.Panel(self)

    border=1
    self.cols=list()
    self.colPicker=list()
    for i in range(len(self.coldesc)):
      cn, cd, is_on, c_color=self.coldesc[i]

      cb=wx.CheckBox(panel, label=cd)
      cb.SetValue(is_on)
      cb.Bind(wx.EVT_CHECKBOX, self.checkChanged)
      self.cols.append(cb)

      cc=wx.ColourPickerCtrl(panel, wx.ID_ANY, c_color)
      cc.Bind(wx.EVT_COLOURPICKER_CHANGED, self.colorChanged)
      self.colPicker.append(cc)
    
    sizer=wx.GridBagSizer(1, 1)
    flag=wx.ALIGN_CENTER_VERTICAL
    for ci in range(len(self.coldesc)):
      sizer.Add(self.cols[ci],      (ci, 0), flag=flag, border=border)
      sizer.Add(self.colPicker[ci], (ci, 1), flag=flag, border=border)

    panel.SetSizer(sizer)
    sizer.Fit(self)


  # ###########################################################
  # Verarbeitet eine Farb-Änderung.
  def colorChanged(self, event):
    for i in range(len(self.colPicker)):
      if self.colPicker[i]==event.GetEventObject():
        curve=self.coldesc[i][0]
        color=self.colPicker[i].GetColour().GetAsString(wx.C2S_HTML_SYNTAX)
        self.parent.curveSettingsFeedback.SetValue("color,%s,%s"%(curve, color))


  # ###########################################################
  # Verarbeitet das An- und Ausschalten von Kurven.
  def checkChanged(self, event):
    for i in range(len(self.cols)):
      if self.cols[i]==event.GetEventObject():
        curve=self.coldesc[i][0]
        if self.cols[i].GetValue(): state=1
        else:                       state=0
        self.parent.curveSettingsFeedback.SetValue("on/off,%s,%s"%(curve, state))
